Index: pacemaker/pengine/test10/order-serialize.exp
===================================================================
--- pacemaker.orig/pengine/test10/order-serialize.exp
+++ pacemaker/pengine/test10/order-serialize.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="13" operation="stop" operation_key="xen-a-fencing_stop_0" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="xen-a-fencing" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_timeout="20000"  hostname="xen-a" interface="lanplus" ipaddr="217.148.178.55" passwd="****" userid="root"/>
+        <attributes CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="20000"  hostname="xen-a" interface="lanplus" ipaddr="217.148.178.55" passwd="****" userid="root"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="12" operation="start" operation_key="xen-a-fencing_start_0" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="xen-a-fencing" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_timeout="20000"  hostname="xen-a" interface="lanplus" ipaddr="217.148.178.55" passwd="****" userid="root"/>
+        <attributes CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="20000"  hostname="xen-a" interface="lanplus" ipaddr="217.148.178.55" passwd="****" userid="root"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -25,7 +25,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="xen-a-fencing_monitor_60000" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="xen-a-fencing" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_start_delay="15000" CRM_meta_timeout="60000"  hostname="xen-a" interface="lanplus" ipaddr="217.148.178.55" passwd="****" userid="root"/>
+        <attributes CRM_meta_interval="60000" CRM_meta_name="monitor" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_start_delay="15000" CRM_meta_timeout="60000"  hostname="xen-a" interface="lanplus" ipaddr="217.148.178.55" passwd="****" userid="root"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -38,7 +38,7 @@
     <action_set>
       <rsc_op id="14" operation="stop" operation_key="xen-b-fencing_stop_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="xen-b-fencing" class="stonith" type="external/ipmi"/>
-        <attributes CRM_meta_timeout="20000"  hostname="xen-b" interface="lanplus" ipaddr="217.148.178.56" passwd="****" userid="root"/>
+        <attributes CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_timeout="20000"  hostname="xen-b" interface="lanplus" ipaddr="217.148.178.56" passwd="****" userid="root"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -47,7 +47,7 @@
     <action_set>
       <rsc_op id="19" operation="migrate_from" operation_key="db_migrate_from_0" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="db" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_timeout="400000"  name="db" xmfile="/etc/xen/db.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="400000"  name="db" xmfile="/etc/xen/db.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -60,7 +60,7 @@
     <action_set>
       <rsc_op id="18" operation="migrate_to" operation_key="db_migrate_to_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="db" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="db" xmfile="/etc/xen/db.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="db" xmfile="/etc/xen/db.cfg"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -69,7 +69,7 @@
     <action_set>
       <rsc_op id="17" operation="monitor" operation_key="db_monitor_10000" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="db" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  name="db" xmfile="/etc/xen/db.cfg"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="20000"  name="db" xmfile="/etc/xen/db.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -97,7 +97,7 @@
     <action_set>
       <rsc_op id="15" operation="stop" operation_key="db_stop_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="db" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="300000"  name="db" xmfile="/etc/xen/db.cfg"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_timeout="300000"  name="db" xmfile="/etc/xen/db.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -110,7 +110,7 @@
     <action_set>
       <rsc_op id="26" operation="migrate_from" operation_key="core-101_migrate_from_0" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="core-101" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_timeout="400000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="400000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -123,7 +123,7 @@
     <action_set>
       <rsc_op id="25" operation="migrate_to" operation_key="core-101_migrate_to_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="core-101" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -132,7 +132,7 @@
     <action_set>
       <rsc_op id="24" operation="monitor" operation_key="core-101_monitor_10000" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="core-101" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_timeout="30000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="30000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -160,7 +160,7 @@
     <action_set>
       <rsc_op id="22" operation="stop" operation_key="core-101_stop_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="core-101" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="300000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_timeout="300000"  name="core-101" xmfile="/etc/xen/core-101.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -173,7 +173,7 @@
     <action_set>
       <rsc_op id="31" operation="migrate_from" operation_key="core-200_migrate_from_0" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="core-200" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_timeout="400000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="400000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -186,7 +186,7 @@
     <action_set>
       <rsc_op id="30" operation="migrate_to" operation_key="core-200_migrate_to_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="core-200" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -199,7 +199,7 @@
     <action_set>
       <rsc_op id="29" operation="monitor" operation_key="core-200_monitor_10000" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="core-200" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="20000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -230,7 +230,7 @@
     <action_set>
       <rsc_op id="27" operation="stop" operation_key="core-200_stop_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="core-200" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="300000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_timeout="300000"  name="core-200" xmfile="/etc/xen/core-200.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -243,7 +243,7 @@
     <action_set>
       <rsc_op id="38" operation="migrate_from" operation_key="edge_migrate_from_0" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="edge" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_timeout="400000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="400000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -256,7 +256,7 @@
     <action_set>
       <rsc_op id="37" operation="migrate_to" operation_key="edge_migrate_to_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="edge" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
       </rsc_op>
     </action_set>
     <inputs/>
@@ -265,7 +265,7 @@
     <action_set>
       <rsc_op id="36" operation="monitor" operation_key="edge_monitor_10000" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="edge" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="20000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -293,7 +293,7 @@
     <action_set>
       <rsc_op id="34" operation="stop" operation_key="edge_stop_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="edge" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="300000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_timeout="300000"  name="edge" xmfile="/etc/xen/edge.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -306,7 +306,7 @@
     <action_set>
       <rsc_op id="43" operation="migrate_from" operation_key="base_migrate_from_0" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="base" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_timeout="400000"  name="base" xmfile="/etc/xen/base.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_from" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="400000"  name="base" xmfile="/etc/xen/base.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -319,7 +319,7 @@
     <action_set>
       <rsc_op id="42" operation="migrate_to" operation_key="base_migrate_to_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="base" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="base" xmfile="/etc/xen/base.cfg"/>
+        <attributes CRM_meta_migrate_source="xen-a" CRM_meta_migrate_target="xen-b" CRM_meta_name="migrate_to" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_record_pending="true" CRM_meta_timeout="400000"  name="base" xmfile="/etc/xen/base.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -332,7 +332,7 @@
     <action_set>
       <rsc_op id="41" operation="monitor" operation_key="base_monitor_10000" on_node="xen-b" on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331">
         <primitive id="base" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_timeout="20000"  name="base" xmfile="/etc/xen/base.cfg"/>
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_node="xen-b" CRM_meta_on_node_uuid="9cb7f556-e0a7-4073-8845-2d7c1d54e331" CRM_meta_timeout="20000"  name="base" xmfile="/etc/xen/base.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
@@ -363,7 +363,7 @@
     <action_set>
       <rsc_op id="39" operation="stop" operation_key="base_stop_0" on_node="xen-a" on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7">
         <primitive id="base" class="ocf" provider="heartbeat" type="Xen"/>
-        <attributes CRM_meta_name="stop" CRM_meta_timeout="300000"  name="base" xmfile="/etc/xen/base.cfg"/>
+        <attributes CRM_meta_name="stop" CRM_meta_on_node="xen-a" CRM_meta_on_node_uuid="445a93d5-655e-430b-b45d-47d79a2f78c7" CRM_meta_timeout="300000"  name="base" xmfile="/etc/xen/base.cfg"/>
       </rsc_op>
     </action_set>
     <inputs>
Index: pacemaker/pengine/test10/order-sets.exp
===================================================================
--- pacemaker.orig/pengine/test10/order-sets.exp
+++ pacemaker/pengine/test10/order-sets.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="8" operation="monitor" operation_key="world1_monitor_10000" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world1" class="ocf" provider="bbnd" type="world1test"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -16,7 +16,7 @@
     <action_set>
       <rsc_op id="7" operation="start" operation_key="world1_start_0" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world1" class="ocf" provider="bbnd" type="world1test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -29,7 +29,7 @@
     <action_set>
       <rsc_op id="6" operation="stop" operation_key="world1_stop_0" on_node="ubuntu_2" on_node_uuid="ubuntu_2">
         <primitive id="world1" class="ocf" provider="bbnd" type="world1test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_2" CRM_meta_on_node_uuid="ubuntu_2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -42,7 +42,7 @@
     <action_set>
       <rsc_op id="11" operation="monitor" operation_key="world2_monitor_10000" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world2" class="ocf" provider="bbnd" type="world2test"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -55,7 +55,7 @@
     <action_set>
       <rsc_op id="10" operation="start" operation_key="world2_start_0" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world2" class="ocf" provider="bbnd" type="world2test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -71,7 +71,7 @@
     <action_set>
       <rsc_op id="9" operation="stop" operation_key="world2_stop_0" on_node="ubuntu_2" on_node_uuid="ubuntu_2">
         <primitive id="world2" class="ocf" provider="bbnd" type="world2test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_2" CRM_meta_on_node_uuid="ubuntu_2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -84,7 +84,7 @@
     <action_set>
       <rsc_op id="14" operation="monitor" operation_key="world3_monitor_10000" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world3" class="ocf" provider="bbnd" type="world3test"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -97,7 +97,7 @@
     <action_set>
       <rsc_op id="13" operation="start" operation_key="world3_start_0" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world3" class="ocf" provider="bbnd" type="world3test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -113,7 +113,7 @@
     <action_set>
       <rsc_op id="12" operation="stop" operation_key="world3_stop_0" on_node="ubuntu_2" on_node_uuid="ubuntu_2">
         <primitive id="world3" class="ocf" provider="bbnd" type="world3test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_2" CRM_meta_on_node_uuid="ubuntu_2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -126,7 +126,7 @@
     <action_set>
       <rsc_op id="17" operation="monitor" operation_key="world4_monitor_10000" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world4" class="ocf" provider="bbnd" type="world4test"/>
-        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_interval="10000" CRM_meta_name="monitor" CRM_meta_on_fail="restart" CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_requires="nothing" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -139,7 +139,7 @@
     <action_set>
       <rsc_op id="16" operation="start" operation_key="world4_start_0" on_node="ubuntu_1" on_node_uuid="ubuntu_1">
         <primitive id="world4" class="ocf" provider="bbnd" type="world4test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_1" CRM_meta_on_node_uuid="ubuntu_1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -155,7 +155,7 @@
     <action_set>
       <rsc_op id="15" operation="stop" operation_key="world4_stop_0" on_node="ubuntu_2" on_node_uuid="ubuntu_2">
         <primitive id="world4" class="ocf" provider="bbnd" type="world4test"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="ubuntu_2" CRM_meta_on_node_uuid="ubuntu_2" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/order-wrong-kind.exp
===================================================================
--- pacemaker.orig/pengine/test10/order-wrong-kind.exp
+++ pacemaker/pengine/test10/order-wrong-kind.exp
@@ -3,7 +3,7 @@
     <action_set>
       <rsc_op id="2" operation="start" operation_key="rsc1_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -12,7 +12,7 @@
     <action_set>
       <rsc_op id="4" operation="start" operation_key="rsc2_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs>
@@ -28,7 +28,7 @@
     <action_set>
       <rsc_op id="3" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
Index: pacemaker/pengine/test10/order1.exp
===================================================================
--- pacemaker.orig/pengine/test10/order1.exp
+++ pacemaker/pengine/test10/order1.exp
@@ -3,7 +3,7 @@
      <action_set>
       <rsc_op id="8" operation="start" operation_key="rsc1_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs>
@@ -19,7 +19,7 @@
      <action_set>
       <rsc_op id="5" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs/>
@@ -28,7 +28,7 @@
      <action_set>
       <rsc_op id="2" operation="monitor" operation_key="rsc1_monitor_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc1" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -37,7 +37,7 @@
     <action_set>
       <rsc_op id="9" operation="start" operation_key="rsc2_start_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -56,7 +56,7 @@
      <action_set>
       <rsc_op id="6" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -65,7 +65,7 @@
      <action_set>
       <rsc_op id="3" operation="monitor" operation_key="rsc2_monitor_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc2" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
@@ -74,7 +74,7 @@
      <action_set>
       <rsc_op id="10" operation="start" operation_key="rsc3_start_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
      <inputs>
@@ -93,7 +93,7 @@
     <action_set>
       <rsc_op id="7" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="uuid2">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node2" CRM_meta_on_node_uuid="uuid2" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
       </rsc_op>
     </action_set>
     <inputs/>
@@ -102,7 +102,7 @@
      <action_set>
       <rsc_op id="4" operation="monitor" operation_key="rsc3_monitor_0" on_node="node1" on_node_uuid="uuid1">
         <primitive id="rsc3" class="heartbeat" type="apache"/>
-        <attributes CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
+        <attributes CRM_meta_on_node="node1" CRM_meta_on_node_uuid="uuid1" CRM_meta_op_target_rc="7" CRM_meta_timeout="20000" />
        </rsc_op>
      </action_set>
     <inputs/>
